/// <reference types="ioredis" />
import * as IORedis from "ioredis";
import { Driver } from "./base";
export interface RedisDriverBaseOptions {
    enableClusterMode?: boolean;
    ioredis?: IORedis.RedisOptions | IORedis.ClusterOptions;
}
export interface RedisDriverStandaloneModeOptions {
    enableClusterMode: false;
    ioredis?: IORedis.RedisOptions;
}
export interface RedisDriverClusterModeOptions {
    enableClusterMode: true;
    ioredis?: IORedis.ClusterOptions;
}
export declare type RedisDriverOptions = RedisDriverBaseOptions | RedisDriverStandaloneModeOptions | RedisDriverClusterModeOptions;
export declare class RedisDriver implements Driver {
    private serverUrl;
    private options;
    client: IORedis.Redis;
    isCluster: boolean;
    constructor(serverUrl: string, options?: RedisDriverOptions);
    touch(key: string, lifetime: number): Promise<boolean>;
    get<Result>(key: string): Promise<any>;
    getMulti<Result>(keys: string[]): Promise<{}>;
    set<Result>(key: string, value: Result, lifetime?: number): Promise<void>;
    del(key: string): Promise<boolean>;
    flush(): Promise<void>;
    end(): Promise<void>;
}
