import { Driver } from "./drivers/base";
export declare class MemcachedFetcher {
    private driver;
    private readonly keyHasher;
    constructor(driver: Driver, options?: {
        keyHashing?: boolean;
    });
    fetch<Result>(key: string, lifetime: number, fetcher: () => Promise<Result>): Promise<Result>;
    del(key: string): Promise<boolean>;
    multiFetch<Argument, Result>(args: Argument[], key: string | [string, (args: Argument) => {
        toString(): string;
    }], lifetime: number, fetcher: (args: Argument[]) => Promise<Result[]>): Promise<Result[]>;
    multiFetchDelete<Argument, Result>(args: Argument[], key: string | [string, (args: Argument) => {
        toString(): string;
    }]): Promise<void>;
}
